/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//-------------------------------------------------------------------
#ifndef CANVASORTHOTEXT_H
#define CANVASORTHOTEXT_H
//-------------------------------------------------------------------
#include <qcanvas.h>
//-------------------------------------------------------------------
class QCanvas;
//-------------------------------------------------------------------
/**
	@author James Fuller,,, <james@slakware12>
*/
class CanvasOrthoText : public QCanvasText {
public:
	CanvasOrthoText ( QCanvas * canvas );

	CanvasOrthoText ( QString & t, QCanvas * canvas );

    CanvasOrthoText ( QString & t, QFont font, QCanvas * canvas );

    ~CanvasOrthoText();

	virtual void draw ( QPainter & painter );

	virtual QRect boundingRect () const;	

	virtual void setupPainter ( QPainter & painter );
	
	void setVertical ( bool bFlag );

	bool vertical ( void );

	int width ();

	int height ();

	bool shadow ( void );

	void setShadow ( bool bFlag );

	virtual int rtti ( void ) const;


private:
	bool  bShadow;
	bool  bVertical;
	void  translate ( QPoint& qp );
};
//-------------------------------------------------------------------
#endif
//-------------------------------------------------------------------

