/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef COLOURFONT_H
#define COLOURFONT_H

#include "doscolourbox.h"
#include <qpainter.h>
#include <kfontdialog.h>

class KConfigGroup;
class QRect;
class QTextParag;

/**
*	Dialog providing font and 'dos colour' choices 

	@author James Fuller,,, <james@slakware12>
*/
class ColourFont : public QWidget {
	Q_OBJECT
	
private:
	KFontChooser  fontDlg;
	QLabel 		sp1;
	LabelIni     labelColour; 
	DosColourBox dcb;
	LabelIni   * labelFont;
	
	LabelIni laPointSize; 
	LabelIni laWeight; 
	
	QString qsItalic;
	QString qsUnderline;
	QString qsOverline;
	QString qsStrikeout;
	
	QString extendKey ( QString sKey, 
						QString sName );
	
private slots:
	void render (void);

public:
	ColourFont(QWidget    * parent, 
			   const char * name,
	  			LabelIni   * li);

    ~ColourFont();

	void write ( KConfigGroup * config, QString sKey );
	void read  ( KConfigGroup * config, QString sKey );
	
// get/set
 	QFont getFont        ( void );

// draw the text
	void setupPainter ( QPainter& painter );
};

//-------------------------------------------------------------------

#endif
