/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef COLOURVALUEPREF_H
#define COLOURVALUEPREF_H
//---------------------------------------------------------------------------
#include "labelini.h"
#include "doscolourbox.h"
#include "spinvalue.h"
#include "scheditprefs.h"
//---------------------------------------------------------------------------
#include <qpainter.h>
#include <qcanvas.h>
//---------------------------------------------------------------------------
class KDialogBase;
class KConfig;
//---------------------------------------------------------------------------
/**
	@author James Fuller,,, <james@slakware12>
*/
class ColourValuePref : public ScheditPrefs {
	Q_OBJECT
private:
	QColor 		 colour;
	LabelIni 	 laColour;
	DosColourBox dcb;	
	//
	LabelIni	 laValue;
	SpinValue 	 svValue;
	//
	QLabel   	 pixLl;
	//
	QCanvasView view;
	QHBoxLayout  * hbLayout;
	
	bool     	 bSpinBox;
	QCanvas 	 canvas;

	void readPreferences  ( KConfigGroup * config );
	void writePreferences ( KConfigGroup * config );
	void renderPage ();

public:
	typedef struct {
		QBrush brush;
		int    iSize;
	} JunctionData;

	ColourValuePref (	KDialogBase * dlg,
						QString qsTitle,
						QString qsKey);
	void showSpinBox ( bool bEnable );
	QColor getColour ();
	int    getValue ();
	void setSpinBoxTitle ( QString qs );
	void setupPainter ( QPainter& painter);
	QCanvas * getCanvas ();
	QVBoxLayout * addLayout ( void );
	QCheckBox * createCb ( QString qs, QVBoxLayout * bl );
	void layoutCb ( QCheckBox * cb, QVBoxLayout * vbLayout );	
	void adjustForCheckBoxes ( void );	
};
//---------------------------------------------------------------------------
#endif
