/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//-------------------------------------------------------------------
#ifndef DOSCOLOURBOX_H
#define DOSCOLOURBOX_H
//-------------------------------------------------------------------
#include <qvaluelist.h>
#include <qptrlist.h>
#include <qwidget.h>
//-------------------------------------------------------------------
#include <kcolordialog.h>
//-------------------------------------------------------------------
#include "labelini.h"
//-------------------------------------------------------------------
class KConfigGroup;
//-------------------------------------------------------------------
/**
A colourbox made up of 16 basic colours used by Dos.
Configurable colours as a group, also to be 
displayable as either 2x8 or 4x4 configuration.

	@author James Fuller,,, <james@slakware12>
*/
class DosColourBox : public KColorCells {
private:
	typedef QValueList<QColor> ColourList;
	typedef QPtrList<DosColourBox> DlgList;
	
	LabelIni * label; 
	
	static ColourList colourList;
	static DlgList    dlgList;
				
public:
	
	DosColourBox(QWidget * parent, const char * name, LabelIni * label);

    ~DosColourBox();
    static void updateColourList (void );
	void shortAndWide ( void );
	void square ( void );
	
	static bool updateColour(unsigned int uiIndex, QColor colour);
    static bool updateAllColours (QValueList<QColor> list);
    QColor& getColour ();
	void setSelected(int);
    QSize minimumSize();
	void write ( KConfigGroup * config, QString sKey = "" );
	void read  ( KConfigGroup * config, QString sKey = "" );
};
//-------------------------------------------------------------------
#endif
