/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LABELINI_H
#define LABELINI_H
//-------------------------------------------------------------------
#include <qlabel.h>
//-------------------------------------------------------------------
class KConfigGroup;
//-------------------------------------------------------------------
/**
	@author James Fuller,,, <james@slakware12>
*/
class LabelIni : public QLabel {
private:
	typedef enum {
		Auto,
  		Bin,
  		Oct,
  		Dec,
  		Hex } Base;
	
	Base base;
	
	bool bFault;
	
	QString keyName ( QString sKey,
					  QString sName );
	
	static unsigned int aBase [];			// Base values
	
	static QStringList aslBase;		// StringList
	
			
public:
	LabelIni ( QWidget * parent, 
			   const char * name = 0, 
			   WFlags f = 0 );
	
	LabelIni ( const QString & text, 
			   QWidget * parent, 
			   const char * name = 0, 
			   WFlags f = 0 );
	
	LabelIni ( QWidget * buddy, 
			   const QString & text, 
			   QWidget * parent, 
			   const char * name = 0, 
			   WFlags f = 0 );
	
    ~LabelIni();

	int read ( 	KConfigGroup * config, 
				QString   sKey, 
				QString   sName = "" );
	
	void write ( KConfigGroup * config, 
				 int		  iValue,
				 QString	  sKey, 
				 QString	  sName = "" );
	
	bool readBool ( KConfigGroup * config, 
					QString   sKey, 
					QString   sName = "" );
	
	void writeBool ( KConfigGroup * config, 
					 bool 			bValue,
					 QString	  sKey, 
					 QString	  sName = "" );

	bool isFault ( void );
	
	bool setBase ( unsigned int uiBase );
	
	bool setBase ( QString qs );
	
	QString getBaseAsString ( void );
	
	static QString getDefaultBase ( void );
	
	static bool setDefaultBase ( unsigned int uiBase );
	
	static bool setDefaultBase ( QString sBase );
		
	static QString getDefaultBaseAsString ( void );	
};

#endif
