/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LINESTYLE_H
#define LINESTYLE_H

#include <qgridview.h>
#include <qpen.h>

#include "labelini.h"
//-------------------------------------------------------------------
class KConfigGroup;
//-------------------------------------------------------------------
// QCoord defined to make it clear we are not dealing with pixels
#define QCoord QPoint 
//-------------------------------------------------------------------
/**
	@author James Fuller,,, <james@slakware12>
*/
class LineStyle : public QGridView {
	Q_OBJECT
			
private:	
	typedef QValueList<PenStyle> StyleList;
	
	static StyleList styleList;
	
	QPen pen;
	
	int selected;
	
	LabelIni * label;
	
	int index ( QCoord qc );
	
	QCoord coord (int iIndex);
	
	void updateCell ( int iIndex, bool bErase );
	
	void setSelected ( QMouseEvent * e);

protected:
	void paintCell ( QPainter * p, int row, int col );
			
public:
	LineStyle ( QWidget * parent, 
				const char *name, 
				LabelIni * li );

    void setPen ( QPen pen );
    QPen& getPen ();
    void mousePressEvent ( QMouseEvent * e );
    void setSelected (int iIndex);
    int getSelected ();
    QSize sizeHint () const;
	void write ( KConfigGroup * config, QString sKey );
	void read (KConfigGroup * config, QString sKey );
	void setupPainter (QPainter& painter);
	
signals:
	void selectionChanged(int);	
};

#endif
