/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

//-------------------------------------------------------------------
#include "pref.h"
#include "scheditfile.h"
#include "scheditprefs.h"
//-------------------------------------------------------------------
#include <klocale.h>
//-------------------------------------------------------------------
#include <qlayout.h>
#include <qlabel.h>
#include <qmessagebox.h>
//-------------------------------------------------------------------
SchematuxPreferences::SchematuxPreferences()
    				 : KDialogBase ( TreeList, 
									 i18n("Schematic Object Preferences"),
                  					 Help|Default|Ok|Apply|Cancel, 
									 Ok ) {
	page = NULL;
										 
	connect ( this, SIGNAL(okClicked()),
			this, SLOT(slotOk()));
	connect ( this, SIGNAL(applyClicked()),
			this, SLOT(slotApply()));
	connect ( this, SIGNAL(helpClicked()),
			  this, SLOT(slotHelp()));
	connect ( this, SIGNAL(defaultClicked()),
			  this, SLOT(slotDefaults()));
			
// ensure page updates before being shown
	connect ( this, SIGNAL(aboutToShowPage(QWidget*)),
			  this, SLOT(newPage(QWidget*)));
									 }
//-------------------------------------------------------------------
void SchematuxPreferences::newPage (QWidget * w) {
	page = (ScheditPrefs *) w;
	int iPage = pageIndex ( w );	
	ScheditPrefs::render ( iPage );
}
//-------------------------------------------------------------------
void SchematuxPreferences::slotOk () {
	slotApply ();	
	emit signalSave ();
	hide ();
}
//-------------------------------------------------------------------
void SchematuxPreferences::slotApply () {
	ScheditPrefs::save ();		// upload data from prefs pages to objects
	emit signalApply ();
}
//-------------------------------------------------------------------
void SchematuxPreferences::slotDefaults () {
	QMessageBox::information ( NULL, "Schematux", "No defaults yet ! :-(", QMessageBox::Ok ); 
}
//-------------------------------------------------------------------
void SchematuxPreferences::slotHelp () {
	QMessageBox::information ( NULL, "Schematux", "No help yet ! :-(", QMessageBox::Ok ); 
}
//-------------------------------------------------------------------
#include "pref.moc"

