/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "qstatusbarkeyval.h"

#include <qfontmetrics.h>

QStatusBarKeyVal::QStatusBarKeyVal ( QString key, QString val, QWidget * parent )
 : QLineEdit(parent)
{
	setFrameStyle ( QFrame::Box | QFrame::Raised );
	setLineWidth ( 2 );
	setMidLineWidth ( 0 );
	setMargin ( 0 );
	
	setFixedHeight ( height () - 5 );
	setReadOnly (true);

	if ( key.isEmpty () ) key = "KEY ";
	qsKey = key;
	if ( val.isEmpty () ) val = "VALUE ";
	qsVal = val;
	adjust ();
}

void QStatusBarKeyVal::adjust ( void ) {
	qsKeyColon = qsKey + " : ";
	iBorder = margin () + frameWidth ();
	
	QRect rectKey = fontMetrics ().boundingRect ( qsKey );
	QRect rectVal = fontMetrics ().boundingRect ( qsVal );
	
	QRect rect;
	iValueX = rectKey.width () + 20 + iBorder;
	setFixedWidth ( iValueX + iBorder + rectVal.width () );
	
	setText ( qsKeyColon + qsVal );
}
	
void QStatusBarKeyVal::setKeyVal ( QString key, QString val ) {
	qsKey = key;
	qsVal = val;
	adjust ();
}

void QStatusBarKeyVal::setVal ( QString qs ) {
	qsVal = qs;
	setText ( qsKeyColon + qsVal );
}

QString QStatusBarKeyVal::getKey ( void ) {
	return qsKey;
}

QString QStatusBarKeyVal::getVal ( void ) {
	return qsVal;
}

QStatusBarKeyVal::~QStatusBarKeyVal()
{
}


