/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SCHEDITANNOTATE_H
#define SCHEDITANNOTATE_H
//---------------------------------------------------------------------------
#include <qptrlist.h>
#include <canvasorthotext.h>
//-------------------------------------------------------------------
class ScheditAnnotatePrefs;
class KDialogBase;
class KConfig;
//-------------------------------------------------------------------
/**
	@author James Fuller,,, <james@slakware12>
*/
class ScheditAnnotate : public CanvasOrthoText {
	private:
#pragma pack (push,1)
		typedef struct {
			unsigned char  		ucType;
			unsigned short int 	usStartX;
			unsigned short int 	usStartY;
			unsigned char  		ucSizeIndex;
			unsigned char  		aucScrap1 [2];
			char  				alText [22];
			unsigned short int 	usScrap2;
		} AnnotateHdr;
#pragma pack (pop)
		
		AnnotateHdr header;
		QString qs;

		QFont font;
		
		int iSize;

		static QColor colour;
		
		static QPtrList<ScheditFontPrefs> aSetupPages;
		
		void setupPainter ( QPainter & painter );
		
		
public:
    ScheditAnnotate ( QCanvas * canvas, 
					  unsigned char * & puc );

    ~ScheditAnnotate();

	int rtti () const;
	
	static void setup ( KDialogBase * dlg );
	
	static void readProperties  ( KConfig * config);
		
	static void writeProperties ( KConfig * config );	
};
//-------------------------------------------------------------------
#endif
//-------------------------------------------------------------------
