/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//---------------------------------------------------------------------------
#ifndef SCHEDITDOCBOX_H
#define SCHEDITDOCBOX_H
//-------------------------------------------------------------------
#include <qpen.h>
#include <qcanvas.h>
//-------------------------------------------------------------------
#include "colourfont.h"
#include "labelini.h"
#include "doscolourbox.h"
#include "spinvalue.h"
#include "scheditprefs.h"
#include "scheditline.h"
#include "scheditfontprefs.h"
//---------------------------------------------------------------------------
class KDialogBase;
class KConfig;
//class ScheditLinePrefs;
class ColourValuePref;
//-------------------------------------------------------------------
/**
	@author James Fuller,,, <james@slakware12>
*/
class ScheditDocBox : public QCanvasRectangle {
public:
//	typedef struct {
//		ScheditLinePrefs::Data line;
//		ScheditFontPrefs::Data font;
//	} Data;
	
private:
#pragma pack (push,1)
	typedef struct {
		unsigned char ucType;               // 0x50
		unsigned short int usStartX;
		unsigned short int usStartY;
		unsigned short int usEndX;
		unsigned short int usEndY;
		unsigned char  aucScrap1 [3];
		unsigned char  ucLines;
		unsigned char  aucScrap2 [3];
	} DocBoxHdr;
#pragma pack (pop)

	DocBoxHdr 	  header;
	char        * pText;
	int           iLength;
	QStringList * sl;
	
	static ScheditFontPrefs * lpFont;
	static ColourValuePref  * lpLine;

public:
    ScheditDocBox ( QCanvas * 		  canvas, 
					unsigned char * & puc );

//    ~ScheditDocBox();

	int rtti () const;
	
	virtual void draw  ( QPainter& painter );
	
	static void setup ( KDialogBase * dlg );
	
	static void readProperties  ( KConfig * config );
		
	static void writeProperties ( KConfig * config );	
};

#endif
