/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SCHEDITFILE_H
#define SCHEDITFILE_H

#include <qstring.h>
#include <qfileinfo.h>
class QCanvas;
class QCanvasItem;
class ScheditHeader;
class KConfig;
class KDialogBase;
		
/**
This class reads the shedit file and createds the schedit objects

	@author James Fuller,,, <james@slakware12>
*/
class ScheditFile  {
private:
	typedef enum {
		eHeader    = 0x00,
		eLine      = 0x10,
		eJunction  = 0x20,
		eAnnotate  = 0x30,
		eDocBox    = 0x50,
		eBitmap    = 0x70
	} eStructType;
	
	QRect           rectPage;
	ScheditHeader * header;
	QCanvas       * canvas;
	QCanvasItem   * so;
	bool            bExtract;
	QString 	    qsExportPath;
	QFileInfo		qfi;
	
	QDataStream fsBitmap;
	QDataStream fsJunction;
	QDataStream fsDocBox;
	QDataStream fsLine;
	QDataStream fsAnnotate;	
	
	void setPage ( int iPageEnum );
	
public:
	ScheditFile (QCanvas * _canvas);

	~ScheditFile();

	void loadFromFile ( QString fileName );
	
	QDataStream * MakeExportFile ( QString qs );

	static void setup ( KDialogBase * dlg );
	
	void saveProperties ( KConfig * config );

	void readProperties ( KConfig * config );
};
//---------------------------------------------------------------------------

#endif
