/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//---------------------------------------------------------------------------
#include <qpen.h>
#include <qmessagebox.h>
//---------------------------------------------------------------------------
#include "scheditfontprefs.h"
//---------------------------------------------------------------------------
ScheditFontPrefs::ScheditFontPrefs ( KDialogBase * dlg,
									 QString qsTitle, 
									 QString qsKey)
	: ScheditPrefs (dlg, qsTitle, qsKey)
	, laColourFont  ( "Font", this )
	, cf ( this, "Font", &laColourFont ) 
	, fm ( cf.getFont () ) {
// Bold section titles
	embolden ( &laColourFont);
	adjustSize ();
}
//---------------------------------------------------------------------------
void ScheditFontPrefs::renderPage () {
	fm = QFontMetrics ( cf.getFont () );
}
//---------------------------------------------------------------------------
/**
 * 
 * @param config 
 */
void ScheditFontPrefs::readPreferences ( KConfigGroup * config ) {
// Colour
	cf.read ( config, sLastKey );
}
//---------------------------------------------------------------------------
void ScheditFontPrefs::writePreferences ( KConfigGroup * config ) {
	cf.write ( config, sLastKey );
}
//---------------------------------------------------------------------------
QFont ScheditFontPrefs::getFont ( void ) {
	return cf.getFont ();
}
//---------------------------------------------------------------------------
QFontMetrics& ScheditFontPrefs::getFontMetrics ( void ) {
	return fm;
}
//---------------------------------------------------------------------------
void ScheditFontPrefs::setupPainter (QPainter& painter) {
	cf.setupPainter (painter);
}
//---------------------------------------------------------------------------
