/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//-------------------------------------------------------------------
#ifndef _SCHEDITANNOTATEPREFS_
#define _SCHEDITANNOTATEPREFS_
//-------------------------------------------------------------------
#include "colourfont.h"
#include "labelini.h"
#include "scheditprefs.h"
//-------------------------------------------------------------------
#include <qfontmetrics.h>
//-------------------------------------------------------------------
// class ScheditFontPrefs - being a dialog window 
//-------------------------------------------------------------------
/**
	@author James Fuller,,, <james@slakware12>
 */
//-------------------------------------------------------------------
class ScheditFontPrefs : public ScheditPrefs {
public:
	typedef struct {
		QColor colour;
		QFont  font;
	} Data;

private:
	LabelIni	laColourFont;
	ColourFont	cf;
	Data		data;
	QFontMetrics fm;
			
	void readPreferences  ( KConfigGroup * config );
	void writePreferences ( KConfigGroup * config );
	
protected:
	void renderPage ();

public:
	ScheditFontPrefs (KDialogBase * dlg,
					  QString 		qsTitle, 
					  QString 		qsKey);
	
	
// get/set
	QFont getFont ( void );
	void setupPainter ( QPainter& painter);
	QFontMetrics& getFontMetrics ( void );
};
//-------------------------------------------------------------------
#endif
