/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SCHEDITJUNCTION_H
#define SCHEDITJUNCTION_H
//-------------------------------------------------------------------
#include "labelini.h"
#include "doscolourbox.h"
#include "spinvalue.h"
#include "scheditprefs.h"
#include <qpainter.h>
#include <qcheckbox.h>
//---------------------------------------------------------------------------
class KDialogBase;
class KConfig;
class ColourValuePref;
//-------------------------------------------------------------------
/**
	@author James Fuller,,, <james@slakware12>
*/
class ScheditJunction : public QCanvasEllipse {
	private:
#pragma pack (push,1)
	typedef struct {
		unsigned char 	   ucType;
		unsigned short int usStartX;
		unsigned short int usStartY;
		unsigned char      aucScrap [11];
	} JunctionHdr;
#pragma pack (pop)
	JunctionHdr header;
	
	static ColourValuePref * 	lp;
	
public:
    ScheditJunction(QCanvas * canvas, unsigned char * & puc);

	ScheditJunction ( QCanvas * canvas, QPoint qp );
			
	~ScheditJunction();

	int rtti () const;
	
	void draw ( QPainter& painter );
	
	static void setup ( KDialogBase * dlg );
	
	static void readProperties ( KConfig * config );
	
	static void writeProperties ( KConfig * config );	
	
	static int point ( int iStyle );
};
//-------------------------------------------------------------------

#endif
