/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "scheditlocatedtext.h"
//---------------------------------------------------------------------------
#include <qpainter.h>
//---------------------------------------------------------------------------
// Create titleblock text objects
QPtrList<ScheditLocatedText> ScheditLocatedText::aslt;
ScheditLocatedText ScheditLocatedText::sltTitle ( 5,	10,  "Title"     );
ScheditLocatedText ScheditLocatedText::sltSize1 ( 5,	39, "Size"      );
ScheditLocatedText ScheditLocatedText::sltNumber ( 57,	39, "Number"    );
ScheditLocatedText ScheditLocatedText::sltRevision ( 257,	39, "Revision"	);	
ScheditLocatedText ScheditLocatedText::sltSheet ( 207,	69, "Sheet"		);
ScheditLocatedText ScheditLocatedText::sltOf    ( 279,	69, "of"		);
ScheditLocatedText ScheditLocatedText::sltDrawn ( 207,	80, "Drawn By:" ); 
//---------------------------------------------------------------------------
// Class ScheditLocatedText
//---------------------------------------------------------------------------
// Default Constructor (for iterator)
ScheditLocatedText::ScheditLocatedText ( void ) {
}
//---------------------------------------------------------------------------
// Equivalence
ScheditLocatedText::ScheditLocatedText ( ScheditLocatedText& slt ) {
	qsStatic  = slt.qsStatic;
	qsDynamic = slt.qsDynamic;
	qp = slt.qp;
}
//---------------------------------------------------------------------------
ScheditLocatedText::ScheditLocatedText ( int x, int y, QString s ) {
	qsStatic  = s;
	qsDynamic = "";
	qp = QPoint ( x, y );
	aslt.append ( this );
}
//---------------------------------------------------------------------------
void ScheditLocatedText::draw ( QPainter& painter ) {
	QString qs;
	
	qs = qsStatic + qsDynamic;
	painter.drawText ( qp, qs );	
}
//---------------------------------------------------------------------------
// call setupPainter before entring the function
void ScheditLocatedText::drawAll ( QPainter& painter ) {
	ScheditLocatedText   slt;
	ScheditLocatedText * it;
	
	for ( it = aslt.first (); it; it = aslt.next () ) {
		slt = *it;
		slt.draw (painter);
	} /* endfor */
}
//---------------------------------------------------------------------------
// call setupPainter before entring the function
void ScheditLocatedText::drawAll ( QPainter& painter,
								   QPtrList<ScheditLocatedText> aslt2 ) {
	ScheditLocatedText   slt;
	ScheditLocatedText * it;
	
	for ( it = aslt2.first (); it; it = aslt2.next () ) {
		slt = *it;
		slt.draw (painter);
	} /* endfor */
}
//---------------------------------------------------------------------------
void ScheditLocatedText::append ( QString qs ) {
	qsDynamic = qs;
}
//---------------------------------------------------------------------------
void ScheditLocatedText::move ( QPtrList<ScheditLocatedText>& aslt2 ) {
	aslt.remove  ( this );
	aslt2.append ( this );
}
//---------------------------------------------------------------------------


