/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SCHEDITLOCATEDTEXT_H
#define SCHEDITLOCATEDTEXT_H
//---------------------------------------------------------------------------
#include <qstring.h>
#include <qpoint.h>
#include <qptrlist.h>
//---------------------------------------------------------------------------
/**
	@author James Fuller,,, <james@slakware12>
*/
class ScheditLocatedText {
private:
	QString qsStatic;
	QString qsDynamic;
	QPoint  qp;

	static QPtrList<ScheditLocatedText> aslt;
	
	static ScheditLocatedText sltTitle;
	static ScheditLocatedText sltSize1;
	static ScheditLocatedText sltNumber;
	static ScheditLocatedText sltRevision;	
	static ScheditLocatedText sltSheet;
	static ScheditLocatedText sltOf;
	static ScheditLocatedText sltDrawn; 
			
public:
	ScheditLocatedText ( void );
	ScheditLocatedText ( ScheditLocatedText& slt );
	ScheditLocatedText ( int x, int y, QString s );
	void draw ( QPainter& painter );
	static void drawAll ( QPainter& painter );
	static void drawAll ( QPainter& painter,
						  QPtrList<ScheditLocatedText> aslt2 );
	void append ( QString qs );
	void move ( QPtrList<ScheditLocatedText>& aslt2 );
};
//---------------------------------------------------------------------------
#endif
