/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SCHEDITMOD0X60_H
#define SCHEDITMOD0X60_H

#include <qcanvas.h>

/**
	@author James Fuller,,, <james@slakware12>
*/
class ScheditMod0x60 : public QCanvasItem {
private:
#pragma pack (push,1)
	typedef struct {
		unsigned char 	   ucType;
		unsigned short int usStartX;
		unsigned short int usStartY;
		unsigned char 	   ucQue1;
		unsigned char 	   ucDia;
		unsigned char 	   ucQue2;
		unsigned short int ausQue3 [4];
	} Mod0x60Hdr;
#pragma pack (pop)
		Mod0x60Hdr header;	
		
public:
	ScheditMod0x60(QCanvas * canvas, unsigned char * & puc);

    ~ScheditMod0x60();

	bool collidesWith ( const QCanvasItem * other ) const;

	bool collidesWith ( const QCanvasSprite * cs,
						const QCanvasPolygonalItem * pi,
						const QCanvasRectangle * cr,
						const QCanvasEllipse * ce,
						const QCanvasText * ct ) const;
	QRect boundingRect ( void ) const;
	void draw ( QPainter& painter );
	virtual int rtti () const;
};

#endif
