/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "scheditpagedef.h"
//---------------------------------------------------------------------------
#include <qpoint.h>
//---------------------------------------------------------------------------
QPtrList<ScheditPageDef> ScheditPageDef::aSpd;
//---------------------------------------------------------------------------
// Create page definitions
ScheditPageDef ScheditPageDef::spd_A4 ( "A4", ScheditPageDef::ePageA4, 1110,  720,  4, 'D' );
ScheditPageDef ScheditPageDef::spd_A3 ( "A3", ScheditPageDef::ePageA3, 1550, 1110,  8, 'F' );
ScheditPageDef ScheditPageDef::spd_A2 ( "A2", ScheditPageDef::ePageA2, 2230, 1570,  8, 'F' );
ScheditPageDef ScheditPageDef::spd_A1 ( "A1", ScheditPageDef::ePageA1, 3150, 2230, 12, 'H' );
ScheditPageDef ScheditPageDef::spd_A0 ( "A0", ScheditPageDef::ePageA0, 4460, 3150, 16, 'L' );
ScheditPageDef ScheditPageDef::spd_A  ( "A",  ScheditPageDef::ePageA, 	950,  750,  4, 'D' );
ScheditPageDef ScheditPageDef::spd_B  ( "B",  ScheditPageDef::ePageB,  1500,  950,  8, 'F' );
ScheditPageDef ScheditPageDef::spd_C  ( "C",  ScheditPageDef::ePageC,  2000, 1500,  8, 'F' );
ScheditPageDef ScheditPageDef::spd_D  ( "D",  ScheditPageDef::ePageD,  3200, 2000, 12, 'H' );
ScheditPageDef ScheditPageDef::spd_E  ( "E",  ScheditPageDef::ePageE,  4500, 3200, 16, 'P' );
//---------------------------------------------------------------------------
ScheditPageDef::ScheditPageDef ( QString pageString,
								 int	 pageOrdinal, 
								 int	 iWidth,
								 int	 iHeight,
								 int	 horMax,
								 char	 verMax ) {
	qsPageID = pageString;
	iPageID = pageOrdinal;
	qsPage.setWidth  ( iWidth  );
	qsPage.setHeight ( iHeight );
	iHorMax  = horMax;
	cVerMax  = verMax;
	
	aSpd.append ( this );		// add to list
}
//---------------------------------------------------------------------------
ScheditPageDef::~ScheditPageDef () {
}
//---------------------------------------------------------------------------
QSize ScheditPageDef::getSize (void) {
	return qsPage;
}
//---------------------------------------------------------------------------
QRect ScheditPageDef::getRect (void) {
	QRect rect;
	QPoint qpOrigin ( 0, 0 );
	
	rect = QRect ( qpOrigin, qsPage );
	return rect;
}
//---------------------------------------------------------------------------
QString ScheditPageDef::getName (void) {
	return qsPageID;
}
//---------------------------------------------------------------------------
int ScheditPageDef::getHdiv (void) {
	return iHorMax;
}
//---------------------------------------------------------------------------
int ScheditPageDef::getVdiv (void) {
	return  cVerMax - '@';
}
//---------------------------------------------------------------------------
// Static Functions
//---------------------------------------------------------------------------
ScheditPageDef * ScheditPageDef::find ( int i ) {
	for ( ScheditPageDef * pSpd = aSpd.first (); pSpd; pSpd = aSpd.next () ) {
		if ( pSpd->iPageID != i ) continue;
		return pSpd;
	} /* endfor */
	
	// not found
	return NULL;	
}
//---------------------------------------------------------------------------
ScheditPageDef * ScheditPageDef::find ( QString page ) {
	for ( ScheditPageDef * pSpd = aSpd.first (); pSpd; pSpd = aSpd.next () ) {
		if ( pSpd->iPageID != page ) continue;
		return pSpd;
	} /* endfor */
	
	// not found
	return NULL;	
}
//---------------------------------------------------------------------------
ScheditPageDef * ScheditPageDef::defPage (void) {
	return &spd_A4;
}
//---------------------------------------------------------------------------


