/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//-------------------------------------------------------------------
#ifndef SCHEDITPREFS_H
#define SCHEDITPREFS_H
//-------------------------------------------------------------------
#include <qframe.h>
#include <qlayout.h>
#include <qpainter.h>
#include <qptrlist.h>
//-------------------------------------------------------------------
class KDialogBase;
class KConfigGroup;
class QCheckBox;
//-------------------------------------------------------------------
/**
Schedit Preferences base class

	@author James Fuller,,, <james@slakware12>
*/
//-------------------------------------------------------------------
class ScheditPrefs : public QFrame {
	Q_OBJECT
	
	protected:	
		QString sLastKey;
		int     iStyle;
	
		void * pLocalData;
		void * pObjectData;
		int iSize;
		
		virtual void renderPage ();

	public slots:
		void render ();
		
	private:
		int iPage;
		
		QString sKey;
		
		QPtrList<QCheckBox> apcb;
		
		static void copy ( void * pDst, void * pSrc, int iCount );
		
		typedef QPtrList<ScheditPrefs> prefsList;
		static prefsList list;
		
		QFrame * addPage ( KDialogBase * dlg,
						   QString 	   qsTitle,
						   QString 	   qsKey);
		virtual void readPreferences  ( KConfigGroup * config ) = 0;
		virtual void writePreferences ( KConfigGroup * config ) = 0;
		
	protected:
		QVBoxLayout layout;
		
	public:
		ScheditPrefs (KDialogBase * dlg,
					  QString 	    qsTitle,
					  QString 	    qsKey);
		ScheditPrefs (KDialogBase * dlg,
					  QString 	    qsKey);
		void embolden ( QWidget * w );
		QString getKey ( void );	
		void readGroup  ( KConfig * config );
		void writeGroup ( KConfig * config );
		QCheckBox * makeCb ( QString qs );		
		void setPage ( int iIndex );
		
		virtual void setupPainter ( QPainter& painter) = 0;
		
		static void load ();
		static void save ();
		
		static void render ( int iIndex );
};
//-------------------------------------------------------------------

#endif
