/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SCHEDITTITLEBLOCK_H
#define SCHEDITTITLEBLOCK_H
//---------------------------------------------------------------------------
#include <qpoint.h>
#include <qsize.h>
#include <qpointarray.h>
#include <qcanvas.h>
//---------------------------------------------------------------------------
#include <scheditfontprefs.h>
#include <scheditline.h>
//---------------------------------------------------------------------------
#include "scheditlocatedtext.h"
//---------------------------------------------------------------------------
class QCheckBox;
class LabelIni;
class QLabel;
class ColourValuePref;

/**
	@author James Fuller,,, <james@slakware12>
*/
class ScheditTitleBlock : public QCanvasRectangle {
private:
// Create titleblock text objects
	QPtrList<ScheditLocatedText> aslt;
	
	ScheditLocatedText sltSize2;
	ScheditLocatedText sltDate;
	ScheditLocatedText sltFile;
	
	QPointArray paTitleBlock;
	QPoint		qpOffset;
	QPoint		qpBlock;
	
	static ScheditFontPrefs * lpText;
	static ColourValuePref  * lpLine;
		
	static QCheckBox * cbBlock;
	static LabelIni  * laVisible;
	static QLabel    * pixLabel;
	
public:
    ScheditTitleBlock( QCanvas * canvas );

    ~ScheditTitleBlock();
	
	void setOffset ( QPoint qp );

	void setFileData ( QFileInfo qfi );

	void setPageSize ( QString qs );

	void draw ( QPainter& painter );

	void drawShape ( QPainter & painter );
	
	void sample ( void );

	static void setup ( KDialogBase * dlg );
	
	static void readProperties  ( KConfig * config );
		
	static void writeProperties ( KConfig * config );	
};

#endif
