/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//-------------------------------------------------------------------
#include <qlineedit.h>
#include <qcanvas.h>
#include <qwmatrix.h>
#include <qradiobutton.h>
//-------------------------------------------------------------------
#include "zoomwin.h"
//-------------------------------------------------------------------
ZoomWin::ZoomWin( QRect rect_canvas,
				  QRect rect_view ) {
	bool bUser;
					  
	rectCanvas = rect_canvas;
	rectView   = rect_view;
	
	bUser = rbUser->isChecked ();
	leZoom->setReadOnly ( !bUser );	// Allow user input only if rbUser is selected
}
//-------------------------------------------------------------------
ZoomWin::~ZoomWin() {
}
//-------------------------------------------------------------------
void ZoomWin::setZoomPercent ( int iZoomPercent ) {
	QString qs;
	
	qs.sprintf ( "%d", iZoomPercent );
	leZoom->setText ( qs );
}
//-------------------------------------------------------------------
void ZoomWin::setZoom ( double dZoom ) {
		QString qs;
	int	    iPercentZoom;
	
	iPercentZoom = ( int ) ( dZoom * 100.0 );
	setZoomPercent ( iPercentZoom );
	leZoom->setReadOnly ( true );				// rbUser is not selected
}
//-------------------------------------------------------------------
void ZoomWin::slotNone () {
	setZoom ( 1.0 );
}
//-------------------------------------------------------------------
void ZoomWin::slotPage () {	
	double dHeight = (double) rectView.height () / (double) rectCanvas.height ();
	double dWidth  = (double) rectView.width  () / (double) rectCanvas.width  ();
	double dLesser = ( dHeight < dWidth ) ? dHeight : dWidth;
	setZoom ( dLesser );
}
//-------------------------------------------------------------------
void ZoomWin::slotWidth () {
	double dWidth = (double) rectView.width  () / (double) rectCanvas.width  ();
	setZoom ( dWidth );
}
//-------------------------------------------------------------------
void ZoomWin::slotHeight () {
	double dHeight = (double) rectView.height () / (double) rectCanvas.height ();
	setZoom ( dHeight );
}
//-------------------------------------------------------------------
void ZoomWin::slotUser () {
	leZoom->setReadOnly ( false );
}
//-------------------------------------------------------------------
// reporting selection
//-------------------------------------------------------------------
int ZoomWin::zoomPercent () {
	QString qs;
	int     iZoomPercent;
	
	qs = leZoom->text ();
	iZoomPercent = qs.toInt ();
	return iZoomPercent;
}
//-------------------------------------------------------------------
ZoomWin::ZoomPref ZoomWin::zoomStyle () {
	if ( rbPage->isChecked   () ) return page;
	if ( rbWidth->isChecked  () ) return width;
	if ( rbHeight->isChecked () ) return height;
	if ( rbUser->isChecked   () ) return user;	
	return none;
}
//-------------------------------------------------------------------


