/***************************************************************************
 *   Copyright (C) 2013 by James Fuller,,,   *
 *   james@slakware12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ZOOMWIN_H
#define ZOOMWIN_H

#include <zoomBaseDlg.h>
#include <qrect.h>

class QCanvas;
class QCanvasView;

/**
	@author James Fuller,,, <james@slakware12>
*/
class ZoomWin : public zoomBaseDlg {
public:
	typedef enum {
		none,
		page,
		height,
		width,
		user } ZoomPref;
	
	ZoomWin ( QRect rectCanvas, 
		      QRect rectView );

    ~ZoomWin();
	int zoomPercent ();
	void setZoomPercent ( int iZoomPercent );
	ZoomPref zoomStyle ();

private:
	QRect rectCanvas;
	QRect rectView;
//	QCanvasView * canvasView;	
	void setZoom ( double dZoom );
	
public  slots:
	virtual void slotNone ();
	virtual void slotPage ();
	virtual void slotWidth ();
	virtual void slotHeight ();
	virtual void slotUser ();
};

#endif
